"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic' }"

Lookup subclass:#NamespaceAwareLookup
	instanceVariableNames:''
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Kernel-Extensions'
!

!NamespaceAwareLookup class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!NamespaceAwareLookup class methodsFor:'initialization'!

initialize

    Instance := self basicNew

    "Created: / 10-07-2010 / 21:12:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!NamespaceAwareLookup class methodsFor:'accessing'!

instance

    ^Instance

    "Created: / 20-05-2010 / 11:18:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-07-2010 / 21:12:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!NamespaceAwareLookup class methodsFor:'lookup'!

lookupMethodForSelector: selector directedTo: searchClass for: receiver withArguments: argArrayOrNil from: sendingContext 

    ^Instance lookupMethodForSelector: selector directedTo: searchClass 
			  for: receiver withArguments: argArrayOrNil 
			  from: sendingContext 

! !

!NamespaceAwareLookup methodsFor:'lookup'!

lookupMethodForSelector: selector directedTo: searchClass for: receiver withArguments: argArrayOrNil from: sendingContext 
    "Invoked by the VM to ask me for a method to fire.
     For details, see comment inLookup>>lookupMethodForSelector:directedTo:for:withArguments:from:"

    | sendingNs queue seen methods |

    sendingNs := sendingContext method 
            ifNil:[nil]                
            ifNotNil:[sendingContext method nameSpace].

    " 
    Transcript 
            show: 'sel='; show: selector; show: ' ns='; show: sendingNs printString; 
            show: ' method=', sendingContext method printString; cr.
    " 

    queue := Queue with: (Array with: sendingNs).
    seen := Set new.
    
    [queue notEmpty] whileTrue: 
        [|namespaces  imports |
        namespaces := queue removeFirst.
        imports := Set new.
        methods := self 
                    lookupMethodsForSelector: selector 
                    directedTo: searchClass 
                    inNamespaces: namespaces.
        methods size == 1 ifTrue:
            [^methods anyOne].
        methods size >  1 ifTrue:
            ["TODO: fix it, it should return a placeholder method"
            ^receiver 
                ambiguousMessage: 
                    (Message 
                        selector: selector
                        arguments: argArrayOrNil)].
        "No method found"
        namespaces do:
            [:namespace|
            namespace ifNotNil:
                [imports addAll: namespace imports]].
        imports isEmpty ifFalse:[queue add: imports]].

    methods := self lookupMethodsForSelector: selector directedTo: searchClass.
    methods size == 1 ifTrue:[^methods anyOne].
    ^nil

    "Modified: / 21-07-2010 / 17:11:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!NamespaceAwareLookup methodsFor:'lookup - helpers'!

lookupMethodsForSelector: selector directedTo: initialSearchClass 

    "Searches initialSearchClass for a methods with in any namespace"
    ^self 
        lookupMethodsForSelector: selector
        directedTo: initialSearchClass
        suchThat:[:sel :mthd|true].

    "Created: / 19-07-2010 / 15:37:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lookupMethodsForSelector: selector directedTo: initialSearchClass inNamespaces: namespaces

    "Searches initialSearchClass for a methods with given selector in given namespaces."
    ^self 
        lookupMethodsForSelector: selector
        directedTo: initialSearchClass
        suchThat:[:sel :mthd|namespaces includes: mthd nameSpace].

    "Created: / 19-07-2010 / 15:13:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lookupMethodsForSelector: selector directedTo: initialSearchClass suchThat: block

    "Searches initialSearchClass for a method with given selector in given nameSpace.
     if no method in given namespace is found, returns nil"

    | searchClass methods seen |

    searchClass := initialSearchClass.
    methods := Set new.
    seen := OrderedCollection new.
    [ searchClass notNil ] whileTrue:        
        [searchClass selectorsAndMethodsDo:
            [:sel :mthd|
            (sel selector = selector 
                and:[(seen includes: mthd nameSpace) not
                    and:[block value: sel value: mthd]]) ifTrue:
                        [methods add: mthd.
                        seen add: mthd nameSpace]].
        searchClass := searchClass superclass].
    ^methods

    "Created: / 19-07-2010 / 15:34:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 20-07-2010 / 10:42:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!NamespaceAwareLookup class methodsFor:'documentation'!

version_SVN
    ^ '$Id: NamespaceAwareLookup.st 10553 2010-07-22 12:32:34Z vranyj1 $'
! !

NamespaceAwareLookup initialize!
